package pLF4_HexBinCalc;

import javax.swing.JPanel;
import javax.swing.JButton;
import java.awt.Color;
import java.awt.Toolkit;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

/****************************************************************************************************
 * 
 * Input for the Calc
 *
 * @author Sven Marceta
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Panel_Input extends JPanel
{

	private static final long serialVersionUID = 1L;
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	Model model;
	
	
	/**
	 * Create the panel.
	 */
	public Panel_Input(Model aModel)
	{
		setLayout(null);
		
		model = aModel;
		
		JButton btnDivide = new JButton("/");
		btnDivide.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setOperation("/");
			}
		});
		btnDivide.setBackground(Color.RED);
		btnDivide.setBounds(10, 11, 94, 38);
		add(btnDivide);
		
		JButton btnMulti = new JButton("*");
		btnMulti.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setOperation("*");
			}
		});
		btnMulti.setBackground(Color.RED);
		btnMulti.setBounds(105, 11, 94, 38);
		add(btnMulti);
		
		JButton btnMinus = new JButton("-");
		btnMinus.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setOperation("-");
			}
		});
		btnMinus.setBackground(Color.RED);
		btnMinus.setBounds(200, 11, 94, 38);
		add(btnMinus);
		
		JButton btnAdd = new JButton("+");
		btnAdd.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setOperation("+");
			}

		});
		btnAdd.setBackground(Color.RED);
		btnAdd.setBounds(295, 11, 94, 38);
		add(btnAdd);
		
		JButton btnNumber_Zero = new JButton("0");
		btnNumber_Zero.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				addNumber("0");
			}
		});
		btnNumber_Zero.setBackground(Color.ORANGE);
		btnNumber_Zero.setBounds(10, 49, 94, 38);
		add(btnNumber_Zero);
		
		JButton btnNumber_One = new JButton("1");
		btnNumber_One.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				addNumber("1");
			}
		});
		btnNumber_One.setBackground(Color.ORANGE);
		btnNumber_One.setBounds(105, 49, 94, 38);
		add(btnNumber_One);
		
		JButton btnSolve = new JButton("=");
		btnSolve.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setOperation("=");
			}
		});
		btnSolve.setBackground(Color.GREEN);
		btnSolve.setBounds(200, 49, 189, 38);
		add(btnSolve);

		
	}
	

	/** TODO Beschreibe die Funktion der Methode, alle Parameter und den Rückgabewert
	 *
	 * @param aString
	 */
	protected void addNumber(String aNumber)
	{
		switch (aNumber)
			{
			case "1", "0":
			{
				if(model != null)
					model.getCalculator().addNumber(aNumber);
			}
			default:
				Toolkit.getDefaultToolkit().beep();
			}
	}


	void setOperation(String aOperation)
	{
		switch (aOperation)
			{
			case "+","-","*","/","=":
			{
				if(model != null)
					model.getCalculator().setOperation(aOperation);
				break;
			}
			default:
				Toolkit.getDefaultToolkit().beep();
			}
		
	}
	
	
}
