package pLF4_HexBinCalc;

import javax.swing.JPanel;
import javax.swing.JTextField;
import java.awt.Color;
import javax.swing.SwingConstants;
import java.awt.Font;
import javax.swing.JLabel;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Panel_View extends JPanel implements _IBinHexView
{

	private static final long serialVersionUID = 1L;
	private static final String REGEX_BIN = "[0-1]{1,}";
	private JTextField txtHexNumber;
	private JTextField txtDexNumber;
	private JTextField txtBinNumber;
	private JTextField txtBinInput;
	private JTextField txtOperator;
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen

	/**
	 * Create the panel.
	 */
	public Panel_View()
	{
		setBackground(Color.WHITE);
		setLayout(null);
		
		txtHexNumber = new JTextField();
		txtHexNumber.setFont(new Font("Tahoma", Font.PLAIN, 20));
		txtHexNumber.setHorizontalAlignment(SwingConstants.RIGHT);
		txtHexNumber.setText("0");
		txtHexNumber.setEditable(false);
		txtHexNumber.setBackground(Color.LIGHT_GRAY);
		txtHexNumber.setBounds(94, 66, 214, 28);
		add(txtHexNumber);
		txtHexNumber.setColumns(10);
		
		txtDexNumber = new JTextField();
		txtDexNumber.setHorizontalAlignment(SwingConstants.RIGHT);
		txtDexNumber.setText("0");
		txtDexNumber.setFont(new Font("Tahoma", Font.PLAIN, 20));
		txtDexNumber.setEditable(false);
		txtDexNumber.setColumns(10);
		txtDexNumber.setBackground(Color.LIGHT_GRAY);
		txtDexNumber.setBounds(94, 96, 214, 28);
		add(txtDexNumber);
		
		txtBinNumber = new JTextField();
		txtBinNumber.setForeground(Color.GREEN);
		txtBinNumber.setText("0");
		txtBinNumber.setHorizontalAlignment(SwingConstants.RIGHT);
		txtBinNumber.setFont(new Font("Tahoma", Font.PLAIN, 20));
		txtBinNumber.setEditable(false);
		txtBinNumber.setColumns(10);
		txtBinNumber.setBackground(Color.LIGHT_GRAY);
		txtBinNumber.setBounds(94, 129, 214, 28);
		add(txtBinNumber);
		
		JLabel lblHex = new JLabel("HEX");
		lblHex.setHorizontalAlignment(SwingConstants.RIGHT);
		lblHex.setFont(new Font("Tahoma", Font.PLAIN, 16));
		lblHex.setBounds(38, 75, 46, 14);
		add(lblHex);
		
		JLabel lblDex = new JLabel("DEX");
		lblDex.setHorizontalAlignment(SwingConstants.RIGHT);
		lblDex.setFont(new Font("Tahoma", Font.PLAIN, 16));
		lblDex.setBounds(38, 105, 46, 14);
		add(lblDex);
		
		JLabel lblBin = new JLabel("BIN");
		lblBin.setHorizontalAlignment(SwingConstants.RIGHT);
		lblBin.setFont(new Font("Tahoma", Font.PLAIN, 16));
		lblBin.setBounds(38, 138, 46, 14);
		add(lblBin);
		
		txtBinInput = new JTextField();
		txtBinInput.setText("0");
		txtBinInput.setHorizontalAlignment(SwingConstants.RIGHT);
		txtBinInput.setForeground(Color.YELLOW);
		txtBinInput.setFont(new Font("Tahoma", Font.PLAIN, 20));
		txtBinInput.setEditable(false);
		txtBinInput.setColumns(10);
		txtBinInput.setBackground(Color.DARK_GRAY);
		txtBinInput.setBounds(38, 168, 270, 28);
		add(txtBinInput);
		
		txtOperator = new JTextField();
		txtOperator.setHorizontalAlignment(SwingConstants.RIGHT);
		txtOperator.setText("+");
		txtOperator.setForeground(Color.RED);
		txtOperator.setFont(new Font("Tahoma", Font.PLAIN, 18));
		txtOperator.setBackground(new Color(255, 215, 0));
		txtOperator.setEditable(false);
		txtOperator.setBounds(318, 129, 30, 28);
		add(txtOperator);
		txtOperator.setColumns(10);

	}
	
	public void SetOperator(String aOperator)
	{
		if(aOperator.isEmpty())
		{
			txtOperator.setText("");
		}
		else txtOperator.setText(aOperator);
	}
	
	public void setBinInput(String aInput)
	{
		if(aInput.isEmpty())
		{
			txtBinInput.setText("");
		}
		else {
			if(aInput.matches(REGEX_BIN))
				txtBinInput.setText(aInput);
		}
	}
	
	public void setResult(int DezNumber)
	{
		txtBinNumber.setText(Integer.toString(DezNumber,2));
		txtDexNumber.setText(Integer.toString(DezNumber,10));
		txtHexNumber.setText(Integer.toString(DezNumber,16));
	}

	/**
	 * @return the txtHexNumber
	 */
	public JTextField getTxtHexNumber()
	{
		return txtHexNumber;
	}

	/**
	 * @param aTxtHexNumber the txtHexNumber to set
	 */
	public void setTxtHexNumber(JTextField aTxtHexNumber)
	{
		txtHexNumber = aTxtHexNumber;
	}

	/**
	 * @return the txtDexNumber
	 */
	public JTextField getTxtDexNumber()
	{
		return txtDexNumber;
	}

	/**
	 * @param aTxtDexNumber the txtDexNumber to set
	 */
	public void setTxtDexNumber(JTextField aTxtDexNumber)
	{
		txtDexNumber = aTxtDexNumber;
	}

	/**
	 * @return the txtBinNumber
	 */
	public JTextField getTxtBinNumber()
	{
		return txtBinNumber;
	}

	/**
	 * @param aString the txtBinNumber to set
	 */
	public void setTxtBinNumber(String aString)
	{
		txtBinNumber.setText(aString);;
	}

	/**
	 * @return the txtBinInput
	 */
	public JTextField getTxtBinInput()
	{
		return txtBinInput;
	}

	/**
	 * @param aTxtBinInput the txtBinInput to set
	 */
	public void setTxtBinInput(JTextField aTxtBinInput)
	{
		txtBinInput = aTxtBinInput;
	}

	/**
	 * @return the txtOperator
	 */
	public JTextField getTxtOperator()
	{
		return txtOperator;
	}

	/**
	 * @param aTxtOperator the txtOperator to set
	 */
	public void setTxtOperator(JTextField aTxtOperator)
	{
		txtOperator = aTxtOperator;
	}
	
	
}
