package ue001_Windowed;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JFrame;
import javax.swing.JPanel;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Sven Marceta
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class MyWindow extends JFrame
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	public MyWindow(String aTitel, int aWidth, int aHeight)
	{
		this.setTitle(aTitel);
		this.setSize(aWidth, aHeight);
		
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		
		
		JPanel panel = new MyPanel(aWidth, aHeight);
		
		this.setContentPane(panel);
		
		this.addKeyListener(new MyKeyListener());
		
		this.addMouseListener(new MouseListener()
		{
			
			@Override
			public void mouseClicked(MouseEvent aE)
			{
				System.out.printf("Clicked: %s - %d - %d \n", aE.getButton(), aE.getX(), aE.getY());
			}

			@Override
			public void mousePressed(MouseEvent aE)
			{
				System.out.printf("Pressed: %s - %d - %d \n", aE.getButton(), aE.getX(), aE.getY());
			}

			@Override
			public void mouseReleased(MouseEvent aE)
			{
				System.out.printf("released: %s - %d - %d \n", aE.getButton(), aE.getX(), aE.getY());
			}

			@Override
			public void mouseEntered(MouseEvent aE)
			{
				System.out.printf("Entered: %s - %d - %d \n", aE.getButton(), aE.getX(), aE.getY());
			}

			@Override
			public void mouseExited(MouseEvent aE)
			{
				System.out.printf("Clicked: %c - %d - %d \n", aE.getButton(), aE.getX(), aE.getY());
			}
		});
		
	}

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main

	private class MyKeyListener implements KeyListener
	{

		@Override
		public void keyTyped(KeyEvent aE)
		{
			System.out.printf("txpend: %c - %d \n", aE.getKeyChar(), aE.getKeyCode());
		}

		@Override
		public void keyPressed(KeyEvent aE)
		{
			System.out.printf("Pressed: %c - %d \n", aE.getKeyChar(), aE.getKeyCode());
		}

		@Override
		public void keyReleased(KeyEvent aE)
		{
			System.out.printf("Released: %c - %d \n", aE.getKeyChar(), aE.getKeyCode());
		}
		
	}
	
	private class MyMouseListner implements MouseListener
	{

		@Override
		public void mouseClicked(MouseEvent aE)
		{
			System.out.printf("Clicked: %s - %d - %d \n", aE.getButton(), aE.getX(), aE.getY());
		}

		@Override
		public void mousePressed(MouseEvent aE)
		{
			System.out.printf("Pressed: %s - %d - %d \n", aE.getButton(), aE.getX(), aE.getY());
		}

		@Override
		public void mouseReleased(MouseEvent aE)
		{
			System.out.printf("released: %s - %d - %d \n", aE.getButton(), aE.getX(), aE.getY());
		}

		@Override
		public void mouseEntered(MouseEvent aE)
		{
			System.out.printf("Entered: %s - %d - %d \n", aE.getButton(), aE.getX(), aE.getY());
		}

		@Override
		public void mouseExited(MouseEvent aE)
		{
			System.out.printf("Clicked: %c - %d - %d \n", aE.getButton(), aE.getX(), aE.getY());
		}
		
	}

	// -------- Ende der Klasse 
}
