package ue915_ZugUni;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Zug
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private Waggon ersterWaggon;
	private Waggon letzterWaggon;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Zug()
	{
		this.ersterWaggon = null;
		this.letzterWaggon = null;
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	//Hinten Dranhängen
	public void add(Waggon neuerWaggon) {
		letzterWaggon = neuerWaggon;
		if(ersterWaggon == null) {
			ersterWaggon = neuerWaggon;
		}
		else {
			Waggon waggon = ersterWaggon;
			while (waggon.getNext() != null)
				waggon = waggon.getNext();
			
			waggon.setNext(neuerWaggon);
			neuerWaggon.setPrev(waggon);
		}
	}
	
	//Vorne Dranhängen
	public void addToFront(Waggon neuerWaggon) {
		ersterWaggon = neuerWaggon;
		if(letzterWaggon == null) {
			letzterWaggon = neuerWaggon;
		}
		else {
			Waggon waggon = letzterWaggon;
			while (waggon.getPrev() != null)
				waggon = waggon.getPrev();
			
			waggon.setPrev(neuerWaggon);
			neuerWaggon.setNext(waggon);
		}
	}
	
	public void remove()
	{
		if(ersterWaggon == null) {
			System.out.printf("Wir haben keine Waggons :( \n");
			return;
		}
		
		//Wenn nur ein Waggon
		if(ersterWaggon.getNext() == null) {
			ersterWaggon = null;
			return;
		}
		
		//Mindestens 2 Waggon vorhanden
		Waggon waggon = ersterWaggon;
		while (waggon.getNext().getNext() != null)
			waggon = waggon.getNext();
		
		//getNext.getNext null -> vorletzter Waggon
		
		waggon.setNext(null);
	}
	
	public void removeFromFront()
	{
		if(letzterWaggon == null) {
			System.out.printf("Wir haben keine Waggons :( \n");
			return;
		}
		
		//Wenn nur ein Waggon
		if(letzterWaggon.getPrev() == null) {
			letzterWaggon = null;
			return;
		}
		
		//Mindestens 2 Waggon vorhanden
		Waggon waggon = letzterWaggon;
		while (waggon.getPrev().getPrev() != null)
			waggon = waggon.getPrev();
		
		//getprev.getprev null -> 3.ter Waggon
		
		waggon.setPrev(null);
	}
	
	public void print() {
		if(ersterWaggon == null)
			System.out.printf("Der ist hat keine Waggon!!! \n");
		else {
			Waggon waggon = ersterWaggon;
			while(waggon != null) {
				System.out.printf("Waggon: %s \n", waggon.toString());
				waggon = waggon.getNext();
			}
		}
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER 


	// -------------------------------------------------------------------------------------
	// TOSTRING



	// -------- Ende der Klasse 
}
