package pUe391_ADObjekte;

/****************************************************************************************************
 * 
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public interface _ILogin
{
	
	/** --------------------------------------------------------------------------------<br>
	 * Gibt den Namen des Benutzers zurück
	 * 
	 * @return	Name
	 */
	public String getName();
	
	/** --------------------------------------------------------------------------------<br>
	 * Gibt die EMail-Adresse des Benutzers zurück
	 * 
	 * @return	EMail-Adresse
	 */
	public String getEMail();
	
	/** --------------------------------------------------------------------------------<br>
	 * Prüft, ob des Passwort mit dem Passwort des Benutzers übereinstimmt.
	 * Also, ob der Benutzer zB das richtige Passwort eingegeben hat.
	 * 
	 * @return	Name
	 */
	public boolean checkPasswort(String passwortToCheck);

}
