package ue120_FigurAbstract;

import java.awt.Color;

import sew.G2D;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Kreis extends Figur
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private int radius;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Kreis(int aX, int aY, Color aFarbe, int aRadius)
	{
		super(aX, aY, aFarbe);
		setRadius(aRadius);
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	public void paint()
	{
		G2D.fillOval(	getX() - getRadius(), // wird minus gerechnet damit die Zeichnung in der Mitte ist
						getY()- getRadius(),
						2*getRadius(),// Radius mal 2 ist gleich Durchmesser
						2*getRadius(),// Radius mal 2 ist gleich Durchmesser
						getFarbe(),
						this);
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER 
	/**
	 * @param aRadius the radius to set
	 */
	public void setRadius(int aRadius)
	{
		if(aRadius <= 0)
			throw new IllegalArgumentException("Radius darf nicht kleiner als null sein");
		radius = aRadius;
	}
	/**
	 * @return the radius
	 */
	public int getRadius()
	{
		return radius;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING



	// -------- Ende der Klasse 
}
