package ue130_TierAbstract;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public abstract class Tier
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	String name;
	

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Tier(String aName)
	{
		//Mit setter initialisiren
		setName(aName);
	}


	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	public abstract void gibLaut();


	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	/**
	 * @return the name
	 */
	public String getName()
	{
		return name;
	}
	/**
	 * @param aName the name to set
	 */
	public void setName(String aName)
	{
		if(aName == null)
			throw new NullPointerException("Name darf nicht null sein");
		if(aName.equals(""))
			throw new IllegalArgumentException("Name darf nicht leer sein");
		name = aName;
	}

	// -------- Ende der Klasse 
}
