package ue134_Haustiere;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public abstract class Haustier implements _IHaustier
{

	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private String name;
	private String rasse;
	private int alter;
	private String lieblingsFutter;
	

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Haustier(String aName, String aRasse, int aAlter)
	{
		if(aRasse == null)
			throw new NullPointerException("Rasse darf nicht NULL sein");
		if(aRasse	.equals(""))		
			throw new IllegalArgumentException("Rasse darf nicht Leer sein");
		rasse = aRasse;
		
		setAlter(aAlter);
		setName(aName);
	}


	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	public abstract void bewegeDich();
	public abstract void gibLaut();
	public abstract void frissEtwas();


	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	@Override
	public String getName()
	{
		return name;
	}

	@Override
	public void setName(String aName)
	{
		if(aName == null)
			throw new NullPointerException("Name darf nicht NULL sein");
		if(aName.equals(""))
			throw new IllegalArgumentException("Name darf nicht Leer sein");
		
		name = aName;
	}

	@Override
	public int getAlter()
	{
		return alter;
	}

	@Override
	public void setAlter(int aAlter)
	{
		if(aAlter < 0)
			throw new IllegalArgumentException("Alter knn nicht weniger als Null sein");
		
		alter = aAlter;
	}

	@Override
	public String getRasse()
	{
		return rasse;
	}

	@Override
	public String getLieblingsFutter()
	{
		return lieblingsFutter;
	}

	@Override
	public void setLieblingsFutter(String aLieblingsFutter)
	{
		if(aLieblingsFutter == null)
			throw new NullPointerException("LieblingsFutter darf nicht NULL sein");
		if(aLieblingsFutter.equals(""))
			throw new IllegalArgumentException("LieblingsFutter darf nicht Leer sein");
		
		lieblingsFutter = aLieblingsFutter;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("Haustier [name=%s, rasse=%s, alter=%s, lieblingsFutter=%s]", name, rasse, alter,
				lieblingsFutter);
	}


	// -------- Ende der Klasse 
}
