package ue134_Haustiere;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Katze extends Haustier
{

	
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private String farbe;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Katze(String aName, String aRasse, String aFarbe, int aAlter)
	{
		super(aName, aRasse, aAlter);
		
		if(aFarbe == null)
			throw new NullPointerException("Farbe darf nicht NULL sein");
		if(aFarbe	.equals(""))		
			throw new IllegalArgumentException("Farbe darf nicht Leer sein");
		
		farbe = aFarbe;
	}

	

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	@Override
	public void bewegeDich()
	{
		System.out.printf("%s: Sie Schleicht herum \n", getName());
	}

	@Override
	public void gibLaut()
	{
		System.out.printf("%s:  MIAU \n", getName());
	}

	@Override
	public void frissEtwas()
	{
		System.out.printf("%s: Sie Liebt Nass Futter\n", getName());
	}
	
	public void schnurre()
	{
		System.out.printf("%s: rrrrrrrrr \n", getName());
	}
	
	public void streicheln()
	{
		System.out.printf("%s; Sie nickt ihr Kopf \n", getName());
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	/**
	 * @return the farbe
	 */
	public String getFarbe()
	{
		return farbe;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("Katze [farbe=%s, getName()=%s, getAlter()=%s, getRasse()=%s, getLieblingsFutter()=%s]",
				farbe, getName(), getAlter(), getRasse(), getLieblingsFutter());
	}


	// -------- Ende der Klasse 
}
