package ue134_Haustiere;

/****************************************************************************************************
 * 
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public interface _IHaustier
{

	// -------------------------------------------------------------------------------------
	/** --------------------------------------------------------------------------------<br>
	 * Da wir nicht wissen welches Tier, können wir nicht sagen wie es sich bewegt
	 * Wir wissen jedoch dass sich ein Tier bewegt!
	 * Wie sich das Tier bewegt, muss in der abgeleiteten Klasse festgelegt werdwen.
	 */
	void bewegeDich();

	/** --------------------------------------------------------------------------------<br>
	 * Da wir nicht wissen welches Tier, können wir nicht sagen welchen laut es von sich gibt.
	 * Wir wissen jedoch dass sich Tiere Laute von sich geben!
	 * Was das Tier für einen Laut macht, muss in der abgeleiteten Klasse festgelegt werdwen.
	 */
	void gibLaut();

	/** --------------------------------------------------------------------------------<br>
	 * Da wir nicht wissen welches Tier, können wir nicht sagen was das Tier frisst.
	 * Wir wissen jedoch dass Tiere etwas fressen.
	 * Was das Tier frisst, muss in der abgeleiteten Klasse festgelegt werdwen.
	 */
	void frissEtwas();

	/** --------------------------------------------------------------------------------<br>
	 * @return 	Name des Tieres
	 */
	String getName();

	/**
	 * Setzt den Namen des Tieres
	 *
	 * @param aName
	 */
	void setName(String aName);

	/** --------------------------------------------------------------------------------<br>
	 * @return	das Alter des Tieres
	 */
	int getAlter();

	/**
	 * Setzt das Alter des Tieres
	 *
	 * @param aAlter
	 */
	void setAlter(int aAlter);

	/** --------------------------------------------------------------------------------<br>
	 * Rasse des Tieres
	 *
	 * @return
	 */
	String getRasse();

	/** --------------------------------------------------------------------------------<br>
	 * @return	das Lieblingsfutter des Tieres
	 */
	String getLieblingsFutter();

	/**
	 * Setzt das Lieblingsfutter des Tieres
	 *
	 * @param aLieblingsFutter
	 */
	void setLieblingsFutter(String aLieblingsFutter);

	// -------------------------------------------------------------------------------------
	String toString();

}