package ue211_Fuhrpark;


/****************************************************************************************************
 * 
 * TODO Auto erzeugen
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Auto extends Fahrzeug
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private char bauart;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Auto(String aFIN, String aMarke, char aTreibstoff, char aBauart)
	{
		super(aFIN, aMarke, aTreibstoff);
		
		aBauart = Character.toUpperCase(aBauart);
		if(aBauart != 'L' && aBauart != 'K' && aBauart != 'C')
			throw new IllegalArgumentException("Bauart muss L, K oder C Sein!");
		
		//Alles gut
		bauart = aBauart;
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN


	// -------------------------------------------------------------------------------------
	// GETTER / SETTER 
	/**
	 * @return the bauart
	 */
	public char getBauart()
	{
		return bauart;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("Auto [bauart=%s, toString()=%s]", bauart, super.toString());
	}

	// -------- Ende der Klasse 
}
