package ue211_Fuhrpark;

/****************************************************************************************************
 * 
 * TODO Motorad erzeugen
 *
 * @authorSven Marceta
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Motorrad extends Fahrzeug
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private double leistung;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Motorrad(String aFIN, String aMarke, char aTreibstoff, double aLeistung)
	{
		super(aFIN, aMarke, aTreibstoff);
		
		if(aLeistung < 0 || aLeistung > 249)
			throw new IllegalArgumentException("Leistung muss zwischen 0 und 250 PS sein");
		
		// Alles okay
		leistung = aLeistung;
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER 
	/**
	 * @return the leistung
	 */
	public double getLeistung()
	{
		return leistung;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("Motorrad [leistung=%s, toString()=%s]", leistung, super.toString());
	}

	// -------- Ende der Klasse 
}
