package ue221_Figurenliste;

import java.awt.Color;

import sew.G2D;
import sew.SewLib;

/****************************************************************************************************
 * 
 * Klasse zum Testen der Figurenliste
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class _Main_FigurenListe
{
	public static void main(String[] args)
	{
		G2D.setVisible();
		FigurenListe liste = new FigurenListe();
		
		// ---------------------------------------------------------------
		// Eine Anzahl zufälliger Figuren zur Liste hinzufügen
		//
		for (int i=0; i<20; i++) {
			int x = SewLib.random(20, 600);
			int y = SewLib.random(20, 600);

			int r = SewLib.random(0, 255);
			int g = SewLib.random(0, 255);
			int b = SewLib.random(0, 255);
			Color col = new Color(r, g, b);
			
			int l = SewLib.random(10, 100);
			int br = SewLib.random(10, 100);
			
			switch (SewLib.random(0, 3))
			{
				case 0: liste.neueFigurHinzufuegen(new Rechteck (x, y,col, true, l, br )); break;
				case 1: liste.neueFigurHinzufuegen(new Quadrat  (x, y,col, true, l ));    break;
				case 2: liste.neueFigurHinzufuegen(new Kreis    (x, y,col, true, l ));    break;
			}
		}
		
		// Liste in der Konsole ausgeben
		liste.printFigurenListe();
		liste.alleFigurenZeichnen();
		
		// zufällige Positionen für die Figuren
		SewLib.wait(1000);
		liste.alleFigurenAufZufaelligePosition();
		liste.alleFigurenZeichnen();

		// Figuren verschieben und neu Färben
		for (int i=0; i<10; i++) {
			liste.alleKreiseAufZufaelligePosition();
			liste.alleRechteckeZufaelligeFaerben();
			SewLib.wait(400);
	    }
		
		// -----------------------------------------------------------------
		// Gib die Anzahl der Kreise, Rechtecke und Quadrate in der Konsole aus
		
		
		// -----------------------------------------------------------------
		// Setze alle Rechtecke 5 mal auf zufällige Positionen
		
		
			// dein Code


		// -----------------------------------------------------------------
		// Setze alle Quadrate 5 mal auf zufällige Positionen
		
			// dein Code


		// -----------------------------------------------------------------
		// Füge 3 neue Rechtecke, 3 neue Quadrate und 3 neue Kreise
		// der Liste hinzu und zeichne alle Figuren neu!
		
			// dein Code

		
	}
	// -------- Ende der Klasse 
}
