package ue012_EMailDialog;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import java.awt.Color;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.border.LineBorder;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Sven Marceta
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class EMailDialog extends JFrame
{

	private JPanel contentPane;
	private JTextField txtVorName;
	private JTextField txtNachName;
	private JTextField txtEmail;
	
	//Regex, alle Zeichen
	private final static String REGEX_EMAIL = "^\\w+[\\w-\\.]*\\@\\w+((-\\w+)|(\\w*))\\.[a-z]{2,3}$";
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen

	/**
	 * Launch the application.
	 */
	public static void main(String[] args)
	{
		EventQueue.invokeLater(new Runnable()
		{
			public void run()
			{
				try
				{
					EMailDialog frame = new EMailDialog();
					frame.setVisible(true);
				} catch (Exception e)
				{
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public EMailDialog()
	{
		setTitle("E-Mail");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 450, 300);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);
		
		JPanel panel = new JPanel();
		panel.setBorder(new LineBorder(new Color(0, 128, 0), 1, true));
		panel.setBackground(new Color(60, 179, 113));
		panel.setBounds(50, 30, 330, 200);
		contentPane.add(panel);
		panel.setLayout(null);
		
		JLabel lblVorName = new JLabel("Vorname:");
		lblVorName.setForeground(new Color(255, 255, 255));
		lblVorName.setBounds(10, 11, 60, 21);
		panel.add(lblVorName);
		
		txtVorName = new JTextField();
		txtVorName.setBounds(80, 11, 240, 20);
		panel.add(txtVorName);
		txtVorName.setColumns(10);
		
		JLabel lblNachName = new JLabel("Nachname:");
		lblNachName.setForeground(new Color(255, 255, 255));
		lblNachName.setBounds(10, 43, 60, 14);
		panel.add(lblNachName);
		
		txtNachName = new JTextField();
		txtNachName.setBounds(80, 42, 240, 20);
		panel.add(txtNachName);
		txtNachName.setColumns(10);
		
		JLabel lblEMail = new JLabel("E-Mail:");
		lblEMail.setForeground(new Color(255, 255, 255));
		lblEMail.setBounds(10, 90, 46, 14);
		panel.add(lblEMail);
		
		txtEmail = new JTextField();
		txtEmail.setEditable(false);
		txtEmail.setBounds(80, 87, 240, 20);
		panel.add(txtEmail);
		txtEmail.setColumns(10);
		
		JButton btnOKButton = new JButton("OK");
		btnOKButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				//Zur E-Mail zumachen
				String eMail = txtVorName.getText() + "." + txtNachName.getText() + "@" + "htltraun.at";
				
				
				if(eMail.matches(REGEX_EMAIL))//In EGEX sind alle zeichen die drinnen sein dürfen
				{
					System.out.printf("Gelungene Ausgabe \n");//Debugging
					
					//In Email angeben
					txtEmail.setText(eMail);
				}
				else//Zeichen sind erhalten die nicht gültig sind
				{
					//Pop up
					//Eine neue Frame wird erstellt, dann Die nachricht, Titel, und letztleich was für eine art von Massage
					JOptionPane.showMessageDialog(new JFrame(), "Ungültige E-Mail!", "Error", JOptionPane.ERROR_MESSAGE);
				}
				System.out.printf("%s \n", eMail); //Debuging
			}
		});
		btnOKButton.setBounds(120, 166, 89, 23);
		panel.add(btnOKButton);
		
		JButton btnCancelButton = new JButton("Cancel");
		btnCancelButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				System.exit(0); //Schleist die panel
			}
		});
		btnCancelButton.setBounds(231, 166, 89, 23);
		panel.add(btnCancelButton);
	}
}
