package ue710_Fraktale;

import javax.swing.JPanel;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

/****************************************************************************************************
 * 
 * Controll Panel
 *
 * @author Sven Marceta
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class ControllPanel extends JPanel
{
	// VAlues of which the Images Move
	double positiveChange = 0.001;
	double negativeChange = -0.001;

	/**
	 * Create the panel.
	 */
	public ControllPanel(FraktelPanel FracPnael)
	{
		setLayout(null);
		this.setSize(200, 500);
		
		//Zooming in and out
		JButton btnZoomIn = new JButton("Zoom In");
		/**
		 * Ads a Action Listener in oder to change the Image
		 */
		btnZoomIn.addActionListener(e -> FracPnael.zoomIn());
		btnZoomIn.setBounds(10, 11, 89, 23);
		add(btnZoomIn);
		
		JButton btnZoomOut = new JButton("Zoom Out");
		/**
		 * Ads a Action Listener in oder to change the Image
		 */
		btnZoomOut.addActionListener(e -> FracPnael.zoomOut());
		btnZoomOut.setBounds(10, 45, 89, 23);
		add(btnZoomOut);
		
		// Reset Button
		
		
		//Buttouns that move the Mandelbrot
		JButton btnOben = new JButton("Oben");
		/**
		 * Ads a Action Listener in oder to change the Image
		 */
		btnOben.addActionListener(e -> FracPnael.move(0, negativeChange));
		btnOben.setBounds(50, 176, 89, 23);
		add(btnOben);
		
		JButton btnLinks = new JButton("Links");
		/**
		 * Ads a Action Listener in oder to change the Image
		 */
		btnLinks.addActionListener(e -> FracPnael.move(negativeChange, 0));
		btnLinks.setBounds(10, 205, 89, 23);
		add(btnLinks);
		
		JButton btnRechts = new JButton("Rechts");
		/**
		 * Ads a Action Listener in oder to change the Image
		 */
		btnRechts.addActionListener(e -> FracPnael.move(positiveChange, 0));
		btnRechts.setBounds(101, 205, 89, 23);
		add(btnRechts);
		
		JButton btnUnten = new JButton("Unten");
		/**
		 * Ads a Action Listener in oder to change the Image
		 */
		btnUnten.addActionListener(e -> FracPnael.move(0, positiveChange));
		btnUnten.setBounds(50, 234, 89, 23);
		add(btnUnten);
		
		//Labe wich funktion as a titel
		JLabel lblBewegen = new JLabel("Bewegen:");
		lblBewegen.setBounds(10, 151, 89, 14);
		add(lblBewegen);
		
		JButton btnReset = new JButton("Reset");
		/**
		 * Ads a Action Listener in oder to change the Image
		 */
		btnReset.addActionListener(e -> FracPnael.reset());
		btnReset.setBounds(10, 321, 89, 23);
		add(btnReset);
		
		JButton btnSave = new JButton("Save");
		/**
		 * Ads a Action Listener in order to Save the image
		 */
		btnSave.addActionListener(e -> FracPnael.save());
		btnSave.setBounds(101, 321, 89, 23);
		add(btnSave);
		
	}
}
