package ue710_Fraktale;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JSplitPane;
import javax.swing.JButton;
import java.awt.FlowLayout;
import javax.swing.BoxLayout;

/****************************************************************************************************
 * 
 * Crats an Widow in which all will be displayed
 *
 * @author Sven Marceta
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class MyFraktal extends JFrame
{

	private JPanel contentPane;
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen

	/**
	 * Launch the application.
	 */
	public static void main(String[] args)
	{
		EventQueue.invokeLater(new Runnable()
		{
			public void run()
			{
				try
				{
					MyFraktal frame = new MyFraktal();
					frame.setVisible(true);
				} catch (Exception e)
				{
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public MyFraktal()
	{
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 570, 490);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);
		
		JSplitPane splitPane = new JSplitPane();
		splitPane.setEnabled(false);
		splitPane.setBounds(10, 11, 535, 429);
		contentPane.add(splitPane);
		
		FraktelPanel fraklPanel = new FraktelPanel();
		splitPane.setRightComponent(fraklPanel);
		
		JPanel controllPlane = new ControllPanel(fraklPanel);
		splitPane.setLeftComponent(controllPlane);
		splitPane.setDividerLocation(controllPlane.getWidth());
		
		
	}
}
