package ue810_UserDb;

import java.sql.SQLException;

import ue810_UserDb.controller.DbController;
import ue810_UserDb.model.DataModel;
import ue810_UserDb.model.User;
import ue810_UserDb.model.UserList;
import ue810_UserDb.view.UserView;

/****************************************************************************************************
 * 	
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Sven Marceta
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class _Main_UserDb
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public static void main(String[] args) throws SQLException
	{
		String url = "jdbc:sqlite:" + "c:/PortableRO/user.db";
		DbController dbController = new DbController(url);
		
		DataModel db = new DataModel(dbController);
		
		db.tbl_User().createTable();
		db.tbl_User().insertData();
		
		UserView view = new UserView();
		
		UserList users = db.tbl_User().selectByName("%Won%");
		while(users.next()) {
			view.printUser(users.getUser());
		}
		
		User myUser = db.tbl_User().selectById(1);
		view.printUser(myUser);
		
		myUser = db.tbl_User().selectById(3);
		view.printUser(myUser);
	}

	// -------- Ende der Klasse 
}
