package ue_916_ZugDoppeltBesser;

import java.awt.KeyEventPostProcessor;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Zug
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private Waggon head;
	private Waggon tail;
	private int size;


	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	public Waggon get(int position) {
		if(position < 0) return null;
		if (position >= size) return null;
		
		Waggon current = head; //vorne
				for (int i=0; i < position; i++)
					current = current.getNext();
		
		return current;
	}
	
	public void add(Waggon neuerWaggon, int position) {
		
		Waggon davor = get(position-1);
		Waggon danach = (davor == null) ? head : davor.getNext();
		
		
		if (davor != null) davor.setNext(neuerWaggon);
		if (danach != null) danach.setPrev(neuerWaggon);
		
		neuerWaggon.setNext(danach);
		neuerWaggon.setPrev(davor);
		
		if(davor == null) head = neuerWaggon;
		if(danach == null) tail = neuerWaggon;
		
		size++;
		
	}
	
	public void remove(Waggon waggon) {
		if(waggon == null) return;
		
		Waggon davor = waggon.getPrev();
		Waggon danach = waggon.getNext();
		
		if (davor != null) davor.setNext(danach);
		if (danach != null)danach.setPrev(davor);
		
		waggon.setNext(null);
		waggon.setPrev(null);
		
		if(waggon == head)  head = danach;
		if(waggon == head) tail = davor;
		
		size--;
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER 


	// -------------------------------------------------------------------------------------
	// TOSTRING



	// -------- Ende der Klasse 
}
