package pUe391_ADObjekte;

/****************************************************************************************************
 * 
 * TODO Erstelt eine benutzerGruppe
 *
 * @author Sven Marceta
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class BenutzerGruppe extends AD_Object
{

	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private Domain domain;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public BenutzerGruppe(String aName, String aBeschreibung, Domain aDomain)
	{
		super(aName, aBeschreibung); //Benützt di superklasse zum setzen
		
		if(aDomain == null) //Überprüft auf NULL
			throw new NullPointerException("die Domain darf nicht Null sein!");
		
		//Alles okay, wird gesetzt
		domain = aDomain;
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER 
	/**
	 * @return the domain
	 */
	public Domain getDomain()
	{
		return domain;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("BenutzerGruppe [domain=%s, toString()=%s]", domain, super.toString());
	}

	// -------- Ende der Klasse 
}
