package pUe391_ADObjekte;

/****************************************************************************************************
 * 
 * TODO Erstellt eine Domain
 *
 * @author Sven Marceta
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Domain extends AD_Object
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private boolean topLevelDomain;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Domain(String aName, String aBeschreibung)
	{
		super(aName, aBeschreibung);
		topLevelDomain = false;
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER 
	/**
	 * @return the topLevelDomain
	 */
	public boolean isTopLevelDomain()
	{
		return topLevelDomain;
	}

	/**
	 * @param aTopLevelDomain the topLevelDomain to set
	 */
	public void setTopLevelDomain(boolean aTopLevelDomain)
	{
		topLevelDomain = aTopLevelDomain;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("Domain [topLevelDomain=%s, toString()=%s]", topLevelDomain, super.toString());
	}

	// -------- Ende der Klasse 
}
