package try_catch;

import java.io.FileNotFoundException;
import java.io.PrintWriter;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class _Main_tryCatch
{
	public static void main(String[] args) 
	{  
		int numbTask = 9;
		switch (numbTask)
			{
			case 0:
			{
				
				try      
		        {  
		        	int data=50/0; //may throw exception   
				}  
				//handling the exception  
				catch(ArithmeticException e)  
				{  
					System.out.println(e);  
			    }
				break;
			}
			case 1:
				{
					try
					{
						int data = 50/0;
						
						System.out.printf("rest of the code\n");
					} catch (ArithmeticException e)
					{
						System.out.print(e);
					}
					break;
				}
			case 2:
				{
					try
					{
						int data = 50/0;
					} catch (Exception e)
					{
						System.out.printf("%s \n", e);
					}
					break;
				}
			case 3:
				{
					try
					{
						int data = 50/0;
					} catch (Exception e)
					{
						System.out.printf("Can't divided by zero \n");
					}
					break;
				}
			case 4:
				{
					try
					{
						PrintWriter pw = new PrintWriter("jtp.txt");
						pw.println("saved");
					} catch (FileNotFoundException e)
					{
						System.out.printf("%s \n", e);
					}
					System.out.printf("Weiter im Code...4 \n");
					break;
				}
			case 5:
				{
					try
					{
						int data = 25/5;
						System.out.printf("data \n", data);
					} catch (NullPointerException e)
					{
						System.out.printf("%s \n", e);
					}finally {
						System.out.printf("finally block is always executed \n");
					}
					System.out.printf("Weiter im Code5...\n");
					break;
				}
			case 6:
				{
					try
					{
						int data = 25/0;
						System.out.printf("data \n", data);
					} catch (NullPointerException e)
					{
						System.out.printf("%s \n", e);
					}finally {
						System.out.printf("finally block is always executed \n");
					}
					System.out.printf("Weiter im Code6...\n");
					break;
				}
			case 7:
				{
					try
					{
						int data = 25/0;
						System.out.printf("data \n", data);
					} catch (ArithmeticException e)
					{
						System.out.printf("%s \n", e);
					}finally {
						System.out.printf("finally block is always executed \n");
					}
					System.out.printf("Weiter im Code7...\n");
					break;
				}
			case 8:
				{
					try
					{
						int a[] = new int[5];
						a[5]=30/0;
					} catch (ArithmeticException e)
					{
						System.out.printf("Arithmetic Exception occurs\n");
					} catch (ArrayIndexOutOfBoundsException e)
					{
						System.out.printf("ArrayIndexOutOfBounds Exception  occurs\n");
					}catch (Exception e)
					{
						System.out.printf("Parent Exception occurs\n");
					}
					System.out.printf("Weiter im Code8...\n");
					break;
				}
			case 9:
				{
					try
					{
						int a[] = new int[5];

						System.out.printf("%d \n", a[10]);
					} catch (ArithmeticException e)
					{
						System.out.printf("Arithmetic Exception occurs\n");
					} catch (ArrayIndexOutOfBoundsException e)
					{
						System.out.printf("ArrayIndexOutOfBounds Exception  occurs\n");
					}catch (Exception e)
					{
						System.out.printf("Parent Exception occurs\n");
					}
					System.out.printf("Weiter im Code9...\n");
					break;
				}
			case 10:
			{
				try
				{
					String s = null;

					System.out.printf("%d \n", s.length());
				} catch (ArithmeticException e)
				{
					System.out.printf("Arithmetic Exception occurs\n");
				} catch (ArrayIndexOutOfBoundsException e)
				{
					System.out.printf("ArrayIndexOutOfBounds Exception  occurs\n");
				}catch (Exception e)
				{
					System.out.printf("Parent Exception occurs\n");
				}
				System.out.printf("Weiter im Code10...\n");
				break;
			}
			case 11:
				{
					try
					{
						int a[] = new int[5];
						a[5] = 30/0;
					} catch (Exception e)
					{
						System.out.printf("common task completed \n");
					} catch (ArithmeticException e)
					{
						System.out.printf("task 1 is completed \n");
					}catch (ArrayIndexOutOfBoundsException e)
					{
						System.out.printf("task 2 completed \n");
					}
					System.out.printf("Weiter im Code11...\n");
					break;
				}
			default:
				throw new IllegalArgumentException("Unexpected value: " + numbTask);
			}
	   }

}
