package ue101_Geraete;

/****************************************************************************************************
 * 
 * Erstellt einen Drucker mit oder ohne Farb-Druck
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Drucker extends Geraet
{
	
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	boolean kannFarbenDrucken;
	

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Drucker(String aBezeichnung, String aHersteller)
	{
		super(aBezeichnung, aHersteller);
	}
	
	public Drucker(String aBezeichnung, String aHersteller, boolean aKannFarbeDrucken)
	{
		super(aBezeichnung, aHersteller);
		setKannFarbenDrucken(aKannFarbeDrucken);
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	public void print()
	{
		super.print();
		System.out.printf("Farbe: %s \n", isKannFarbenDrucken());
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER 
	/**
	 * @param aKannFarbenDrucken the kannFarbenDrucken to set
	 */
	public void setKannFarbenDrucken(boolean aKannFarbenDrucken)
	{
		kannFarbenDrucken = aKannFarbenDrucken;
	}
	/**
	 * @return the kannFarbenDrucken
	 */
	public boolean isKannFarbenDrucken()
	{
		return kannFarbenDrucken;
	}

	

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("Drucker [kannFarbenDrucken=%s]", kannFarbenDrucken);
	}

	// -------- Ende der Klasse 
}
