package ue141L_HerrDerRinge;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Elfe extends Wesen
{
	// -------------------------------------------------------------------------------------
		// Instanzvariablen/Klassenvariablen
		private int alter;

		// -------------------------------------------------------------------------------------
		// KONSTRUKTOR oder main
		public Elfe(String aName, int aStaerke, String aWaffe, int aAlter)
		{
			super(aName, aStaerke, aWaffe);
			setAlter(aAlter);
		}

		// -------------------------------------------------------------------------------------
		// INSTANZMETHODEN
		@Override
		public void kaempfen()
		{
			System.out.printf("Elfe %s: Du Hast mein Bogen \n", getName());
		}


		@Override
		public void schlafen()
		{
			System.out.printf("Elfe %s: Muss ich nicht \n\n", getName());
		}


		@Override
		public void laufen()
		{
			System.out.printf("Elfe %s: Loss! \n", getName());		
		}

		public void bogenSchiessen()
		{
			System.out.printf("Elfe %s: Ich nicht verfehlen \n", getName());
		}

		// -------------------------------------------------------------------------------------
		// GETTER / SETTER
		/**
		 * @return the alter
		 */
		public int getAlter()
		{
			return alter;
		}
		/**
		 * @param aAlter the alter to set
		 */
		public void setAlter(int aAlter)
		{
			if(aAlter < 0)
				throw new IllegalArgumentException("Alter darf nicht kleiner als 0 sein!");
			alter = aAlter;
		}

		

		// -------------------------------------------------------------------------------------
		// TOSTRING
		@Override
		public String toString()
		{
			System.out.print("Elfe");
			System.out.printf(super.toString());
			return String.format(" [alter=%s]", alter);
		}
}
