package ue141L_HerrDerRinge;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Zauberer extends Wesen
{

	
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private String status;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Zauberer(String aName, int aStaerke, String aWaffe, String aStatus)
	{
		super(aName, aStaerke, aWaffe);
		setStatus(aStatus);
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	@Override
	public void kaempfen()
	{
		System.out.printf("Zauberer %s: DU KOMMST NICHT VORBEI! \n", getName());
	}

	@Override
	public void schlafen()
	{
		System.out.printf("Zauberer %s: Das ist die beste medizien \n", getName());
	}

	@Override
	public void laufen()
	{
		System.out.printf("Zauberer %s: Ach, wir hätten fliegen sollen \n", getName());
	}
	
	public void zaubern()
	{
		System.out.printf("Zauberer %s: Schlafe Caradhras, sei still, ruhe, nuitho i 'ruith! \n", getName());
	}
	
	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	/**
	 * @return the status
	 */
	public String getStatus()
	{
		return status;
	}
	/**
	 * @param aStatus the status to set
	 */
	public void setStatus(String aStatus)
	{
		if(aStatus == null)
			throw new NullPointerException("Status darf nicht null sein");
		if(aStatus.equals(""))
			throw new IllegalArgumentException("Status darf nicht leer sein");
		
		status = aStatus;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format(
				"Zauberer [Status=%s, Name=%s, Staerke=%s, Waffe=%s, FreundVon=%s, X=%s, Y=%s]",
				getStatus(), getName(), getStaerke(), getWaffe(), getFreundVon(), getX(), getY());
	}


	// -------- Ende der Klasse 
}
