package ue321_Hardware;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Hardware
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private String bezeichnung;
	private String hersteller;
	

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Hardware(String aBezeichnung, String aHersteller)
	{
		//Im Setter ist auch Überprüfungen
		setBezeichnung(aBezeichnung);
		setHersteller(aHersteller);
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	/**
	 * @return the bezeichnung
	 */
	public String getBezeichnung()
	{
		return bezeichnung;
	}

	/**
	 * @param aBezeichnung the bezeichnung to set
	 */
	public void setBezeichnung(String aBezeichnung)
	{
		//Überprüfung das ABezeichnung nicht NUll oder leer ist
		if(aBezeichnung == null)
			throw new NullPointerException("Bezeichnung darf nicht NULL sein!");
		if(aBezeichnung.isEmpty())
			throw new IllegalArgumentException("Bezeichnung darf nicht Leer sein");
		
		//Alles korekt
		bezeichnung = aBezeichnung;
	}

	/**
	 * @return the hersteller
	 */
	public String getHersteller()
	{
		return hersteller;
	}

	/**
	 * @param aHersteller the hersteller to set
	 */
	public void setHersteller(String aHersteller)
	{
		//Überprüfung das aHersteller nicht NUll oder leer ist
		if(aHersteller == null)
			throw new NullPointerException("Hersteller darf nicht NULL sein!");
		if(aHersteller.isEmpty())
			throw new IllegalArgumentException("Hersteller darf nicht Leer sein");
		
		//Alles korekt
		hersteller = aHersteller;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	/**
	 * Gibt alle Werte als String zurück
	 */
	@Override
	public String toString()
	{
		return String.format("Hardware [bezeichnung=%s, hersteller=%s]", bezeichnung, hersteller);
	}

	// -------- Ende der Klasse 
}
