package ue321_Hardware;

import static org.junit.jupiter.api.Assertions.*;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

/****************************************************************************************************
 * 
 * TODO
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
class _JUT_Hardware
{

	// -------------------------------------------------------------------------------------
	// INSTANZVARIABLEN
	Notebook notebook;
	
	@BeforeEach
	void setUp() throws Exception
	{
		notebook = new Notebook("Surface Pro", "Microsoft");
	}

	
	
	@Test
	void testNotebook()
	{
		// -----------------------------------------------------------------
		// Teste Bezeichnung
		assertEquals("Surface Pro", notebook.getBezeichnung());
		notebook.setBezeichnung("Andere Bezeichnung");
		assertEquals("Andere Bezeichnung", notebook.getBezeichnung());
		
		
		assertThrows(NullPointerException.class,
						() -> {notebook.setBezeichnung(null);},
						"Bezeichnung darf nicht NULL sein!");
		
		//notebook.setBezeichnung(null);
		//assertNull(notebook.getBezeichnung());
		
		

		// -----------------------------------------------------------------
		// Teste Hersteller
		assertEquals("Microsoft", notebook.getHersteller());
		notebook.setHersteller("Anderer Hersteller");
		assertEquals("Anderer Hersteller", notebook.getHersteller());
		
		//notebook.setHersteller(null);
		//assertNull(notebook.getHersteller());
		
		assertThrows(NullPointerException.class,
				() -> {notebook.setHersteller(null);},
				"Hersteller darf nicht NULL sein!");
	}

	@Test
	void testIP4Basic()
	{
		// -----------------------------------------------------------------
		// Teste, Interface
		_IIP4_Basics ip = notebook;
		
		// -----------------------------------------------------------------
		// Teste IP4-Adresse
		ip.setAdresse("10.0.0.1");
		assertEquals("10.0.0.1", ip.getAdresse());

		ip.setSubNet("255.255.255.0");
		assertEquals("255.255.255.0", ip.getSubNet());
	}

	// -------- Ende der Klasse 
}
