package ue601_Snake;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

import javax.swing.JPanel;
import javax.swing.Timer;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Sven Marceta
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Game extends JPanel
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	
	private Snake snake = new Snake();

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Game()
	{
		super();
		setFocusable(true);
		requestFocus();
		setBackground(Color.green);
		
		addKeyListener(
				
				//keyadapter------------------------------------------
				new KeyAdapter()
				{
					//Methode
					public void keyPressed(KeyEvent e) {
						
						int code = e.getKeyCode();
						
						System.out.printf("Taste %d \n", code);
						
						switch(e.getKeyCode())
						{
						case KeyEvent.VK_UP: 	snake.moveUp(); 	break;
						case KeyEvent.VK_DOWN: 	snake.moveDown(); 	break;
						case KeyEvent.VK_LEFT: 	snake.moveLeft(); 	break;
						case KeyEvent.VK_RIGHT: snake.moveRight(); 	break;
						}
						
						repaint();
					};//Ende Methode
					
				}//Ende keaAdapter
				
				
				
				
				
				
				);
		Timer tmr = new Timer(100, new ActionListener()
		{
			
			@Override
			public void actionPerformed(ActionEvent aE)
			{
				snake.moveRight();
				repaint();
			}
		});
		tmr.start();
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	@Override
	protected void paintComponent(Graphics aG)
	{
		super.paintComponent(aG);
		snake.paint(aG);
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER 


	// -------------------------------------------------------------------------------------
	// TOSTRING



	// -------- Ende der Klasse 
}
