package ue601_Snake;

import java.awt.Graphics;
import java.awt.Graphics2D;
import java.util.ArrayList;

/****************************************************************************************************
 * 
 * TODO om
 *
 * @author Sven Marceta
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Snake
{
	private static final int MOVE_UP 	= 0;
	private static final int MOVE_DOWN 	= 1;
	private static final int MOVE_LEFT 	= 2;
	private static final int MOVE_RIGHT	= 3;
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	ArrayList<SnakeBody> snake = new ArrayList<>();

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Snake()
	{
		snake.add(new SnakeBody(5, 5) );
		snake.add(new SnakeBody(5, 6) );
		snake.add(new SnakeBody(5, 7) );
		snake.add(new SnakeBody(5, 8) );
		snake.add(new SnakeBody(5, 9) );
		snake.add(new SnakeBody(5, 10) );
		snake.add(new SnakeBody(5, 11) );
		snake.add(new SnakeBody(5, 12) );
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	/** TODO Zeichnet Körper
	 *
	 */
	public void paint(Graphics aG)
	{
		Graphics2D g2D = (Graphics2D)aG;
		for(SnakeBody einBody: snake)
		{
			einBody.paint(g2D);
		}
	}
	
	public void move(int direction)
	{
		int x = snake.get(0).getX();
		int y = snake.get(0).getY();
		
		switch(direction)
		{
		case 0: y--; break; //Down
		case 1: y++; break; //Up
		case 2: x--; break; //Left
		case 3: x++; break; //Right
		}
		
		SnakeBody head = new SnakeBody(x,y);
		
		snake.add(0, head);
		
		int lastIdx = snake.size()-1;
		snake.remove(lastIdx);
	}
	
	/** 
	 *
	 */
	public void moveUp()
	{
		move(MOVE_UP);
	}
	
	/** 
	 *
	 */
	public void moveDown()
	{
		move(MOVE_DOWN);
	}
	
	public void moveLeft()
	{
		move(MOVE_LEFT);
	}
	
	public void moveRight()
	{
		move(MOVE_RIGHT);
		
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER 


	// -------------------------------------------------------------------------------------
	// TOSTRING



	// -------- Ende der Klasse 
}
